#include "stdafx.h"
#include "scbase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSCBase::CSCBase()
{
	hCom=INVALID_HANDLE_VALUE;
	// create events
	timeEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
}
CSCBase::~CSCBase()
{
	CloseHandle(timeEvent);
	Close();
}
BYTE CSCBase::adapt(BYTE b)
{
	int i;
	BYTE y,mask,mask2,res;

	y=~b;
	mask=0x01;
	mask2=0x80;
	res=0;
	for(i=0;i<8;i++)
	{
	  if (y & mask)
			res|=mask2;
	  mask<<=1;
	  mask2>>=1;
	}
	return res;
}
DWORD CSCBase::Read(BYTE *buf,DWORD bytes_to_read,DWORD wait)
{
	DWORD bytes_read,cnt;
	BYTE  *buf2;

	cnt=0;
	buf2=buf;
	ReadFile(hCom,(void*)buf,bytes_to_read,&bytes_read,NULL);
	cnt+=bytes_read;
	while (wait>0 && cnt<bytes_to_read)
	{
		WaitForSingleObject(timeEvent,200);
		buf2+=bytes_read;
		ReadFile(hCom,(void*)buf2,bytes_to_read-cnt,&bytes_read,NULL);
		cnt+=bytes_read;
		wait--;
	}
	
	if (invert)
	{
		for(bytes_read=0;bytes_read<cnt;bytes_read++)
			buf[bytes_read]=adapt(buf[bytes_read]);
	}

	return cnt;
}
DWORD CSCBase::Write(BYTE *buf,DWORD bytes_to_write)
{
	DWORD bytes_written;
	if (invert)
	{
		for(bytes_written=0;bytes_written<bytes_to_write;bytes_written++)
			loc_buf[bytes_written]=adapt(buf[bytes_written]);
		WriteFile(hCom,(void*)loc_buf,bytes_to_write,&bytes_written,NULL);
	}
	else
	{
		WriteFile(hCom,(void*)buf,bytes_to_write,&bytes_written,NULL);
	}
	return bytes_written;
}
void CSCBase::DoReset(const char *serconfig)
{
	SetConfig(serconfig);

	//DWORD	dw;
	//GetCommModemStatus(hCom,&dw);

	EscapeCommFunction(hCom,SETRTS);
	//GetCommModemStatus(hCom,&dw);
	WaitForSingleObject(timeEvent,50);
	EscapeCommFunction(hCom,CLRRTS);
	//GetCommModemStatus(hCom,&dw);
	WaitForSingleObject(timeEvent,250);
}
void CSCBase::SetConfig(const char *serconfig)
{
	DCB		dcb;
	BOOL	fSuccess;
	DWORD	dwError;

	if (hCom==INVALID_HANDLE_VALUE)
		return;

	fSuccess = GetCommState(hCom, &dcb);
	if (!fSuccess) 
	{
		AfxMessageBox("GetCommState failed",MB_OK);
		CloseHandle(hCom);
		return;
	}
	fSuccess = BuildCommDCB(serconfig,&dcb);
	if (!fSuccess) 
	{
		AfxMessageBox("BuildCommDCB failed",MB_OK);
		CloseHandle(hCom);
		return;
	}
	dcb.fRtsControl=RTS_CONTROL_DISABLE;
	fSuccess = SetCommState(hCom, &dcb);
	if (!fSuccess) 
	{
		dwError=GetLastError();
		AfxMessageBox("SetCommState failed",MB_OK);
		CloseHandle(hCom);
		return;
	}
}
void CSCBase::Close()
{
	CloseHandle(hCom);
	hCom=INVALID_HANDLE_VALUE;
}
void CSCBase::Open(const char *serconfig)
{
	COMMTIMEOUTS	timeouts;
	char			string[16];
	BOOL	fSuccess;

	memcpy(string,serconfig,4);
	string[4]=0x00;
	hCom = CreateFile(string,GENERIC_READ | GENERIC_WRITE,
					   0, NULL,OPEN_EXISTING, 0,NULL);
	if (hCom == INVALID_HANDLE_VALUE)
	{    
		AfxMessageBox("Could not create handle",MB_OK);
		return;
	}
	
	fSuccess = SetupComm(hCom,1024,1024);
	if (!fSuccess) 
	{
		AfxMessageBox("SetupComm failed",MB_OK);
		CloseHandle(hCom);
		return;
	}
	fSuccess = GetCommTimeouts(hCom,&timeouts);
	if (!fSuccess) 
	{
		AfxMessageBox("GetCommTimeouts failed",MB_OK);
		CloseHandle(hCom);
		return;
	}
	timeouts.ReadIntervalTimeout=MAXDWORD;
	fSuccess = SetCommTimeouts(hCom,&timeouts);
	if (!fSuccess) 
	{
		AfxMessageBox("SetCommTimeouts failed",MB_OK);
		CloseHandle(hCom);
		return;
	}
}
void CSCBase::SetInvert(int p)
{
	invert=p;
}